<xsl:stylesheet 
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
    version="2.0"
    exclude-result-prefixes="xs">

    <xsl:output   
	method="xml" 
	version="1.0"
	encoding="utf-8"
	indent="yes"/>
    
    <xsl:strip-space elements="*" />
    
    <xsl:template match="//network">
	<network>
	  <xsl:copy-of select="@*"/>
	  <xsl:attribute name="kind">elim-split-point</xsl:attribute>
<!--	  <xsl:copy-of select="comment"/> -->
	  <xsl:apply-templates select="comment|metabolite|protein|actor|species|context|reaction|expression|parameter|equal"/>
<!--	  <xsl:copy-of select="protein|actor"/> -->
<!--	  <xsl:apply-templates select="context|reaction"/> -->
	</network>
    </xsl:template>

    <xsl:template match="reaction">
      <reaction> 
	<xsl:copy-of select="@*"/>
	<xsl:apply-templates select="*"/>
      </reaction>
    </xsl:template>

    <xsl:template match="context|kinetics|comment">
	<xsl:copy-of select="."/>
    </xsl:template>
    
    <xsl:template match="kinetic-expression">
      <xsl:copy-of select="."/>
    </xsl:template>

     <xsl:template match="expression|parameter">
      <xsl:copy-of select="."/>
    </xsl:template>
    
    <xsl:template match="*[@spec]">
      <xsl:variable name="tag">
	<xsl:value-of select="name(.)"/>
      </xsl:variable>
      <xsl:element name="{$tag}">
	<xsl:copy-of select="@spec"/>
	<xsl:copy-of select="@stoichiometry"/>
      </xsl:element>
    </xsl:template>
    
    <xsl:template match="metabolite|protein|actor|species">
      <xsl:variable name="tag">
	<xsl:value-of select="name(.)"/>
      </xsl:variable>
      <xsl:element name="{$tag}">
	<xsl:copy-of select="*|@*|comment"/>
      </xsl:element>
   </xsl:template>
   <xsl:template match="equal">
     <xsl:copy-of select="."/>
   </xsl:template>
</xsl:stylesheet>
