<xsl:stylesheet 
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
    version="2.0"
    exclude-result-prefixes="xs">

    <xsl:output   
	method="xml" 
	version="1.0"
	encoding="utf-8"
	indent="yes"/>
    
    <xsl:template match="equations">

      <xsl:variable name="split-ODEs">
	<xsl:apply-templates select="." mode="split-signs"/>
      </xsl:variable>

      <xsl:variable name="zero-ODEs">
	<xsl:apply-templates select="." mode="zero"/>
      </xsl:variable>
      
      <xsl:result-document href="zero-ODEs.xml">
	<xsl:copy-of select="$zero-ODEs"/>
      </xsl:result-document>
      
      <xsl:copy-of select="$split-ODEs"/>
    </xsl:template>

       <!-- function split-signs -->

    <xsl:template match="dot" mode="split-signs">
      <sum>
	<posdot>
	  <xsl:copy-of  select="@spec"/>
	</posdot>
	<minus>
	  <negdot>
	    <xsl:copy-of  select="@spec"/>
	  </negdot>
	</minus>
      </sum>
    </xsl:template>

    <xsl:template match="*" mode="split-signs">
       <xsl:variable name="tag">
	 <xsl:value-of select="name(.)"/>
       </xsl:variable>
       <xsl:element name="{$tag}">
	<xsl:apply-templates select="@*|*|text()| comment()" mode="split-signs"/>
      </xsl:element>
    </xsl:template>

    <xsl:template match="@*|text()|comment()" mode="split-signs">
      <xsl:copy-of select="."/>
    </xsl:template>

    <!-- function zero : replace derivate variables by zero -->

    <xsl:template match="dot" mode="zero">
      <sum/>
    </xsl:template>

    <xsl:template match="equations" mode="zero">
      <steady-state>
	<xsl:apply-templates select="*|@*|text()|comment()" mode="zero"/>
      </steady-state>
    </xsl:template>

    <xsl:template match="*" mode="zero">
       <xsl:variable name="tag">
	 <xsl:value-of select="name(.)"/>
       </xsl:variable>
       <xsl:element name="{$tag}">
	<xsl:apply-templates select="@*|*|text()| comment()" mode="zero"/>
      </xsl:element>
    </xsl:template>

    <xsl:template match="@*|text()|comment()" mode="zero">
      <xsl:copy-of select="."/>
    </xsl:template>

</xsl:stylesheet>
