<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet 
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    version="2.0"
    exclude-result-prefixes="xs">

  <xsl:output   
      method="xml" 
      version="1.0"
      encoding="utf-8"
      indent="yes"/>

  <xsl:template match="network">
    <xsl:variable name="tag">
	<xsl:value-of select="name(.)"/>
      </xsl:variable>
    <xsl:element name="{$tag}"> 
      <xsl:copy-of select="@*"/>
      <xsl:attribute name="network-version">2.0</xsl:attribute>
      <xsl:apply-templates select="child::*"/>
    </xsl:element>
  </xsl:template>
  <xsl:template match="species">
    <xsl:copy-of select="."/>
  </xsl:template>
  <xsl:template match="metabolite|protein|actor">
    <xsl:variable name="tag">
	<xsl:value-of select="name(.)"/>
      </xsl:variable>
    <species>
      <xsl:attribute name="type">
	<xsl:value-of select="$tag"/>
      </xsl:attribute>
      <xsl:copy-of select="@* | child::*"/>
    </species>
  </xsl:template>
  <xsl:template match="reaction|edgecluster|comment">
    <xsl:copy-of select="."/>
  </xsl:template>
  <xsl:template match="context">
    <reaction>
      <xsl:copy-of select="@*"/>
      <xsl:apply-templates select="child::*"/>
    </reaction>
  </xsl:template>
  <xsl:template match="input">
    <xsl:attribute name="type">inflow</xsl:attribute>
    <product>
      <xsl:copy-of select="@*"/>
    </product>
  </xsl:template>
  <xsl:template match="output">
    <xsl:attribute name="type">outflow</xsl:attribute>
    <reactant>
      <xsl:copy-of select="@*"/>
    </reactant>
  </xsl:template>

</xsl:stylesheet>
