<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet 
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    version="2.0"
    exclude-result-prefixes="xs">

  <xsl:output   
      method="xml" 
      version="1.0"
      encoding="utf-8"
      indent="yes"/>
  

  
  <xsl:template match="network">
    <!--<xsl:message>
      hi network
    </xsl:message>-->
    <xsl:variable name="tag">
	<xsl:value-of select="name(.)"/>
      </xsl:variable>
    <xsl:element name="{$tag}"> 
      <xsl:copy-of select="@*"/>
      <xsl:attribute name="network-version">2.1</xsl:attribute>
      <xsl:apply-templates select="*"/>
    </xsl:element>
  </xsl:template>

  <xsl:template match="mult">
    <times>
      <xsl:apply-templates select="@*|*|text()|comment()"/>
    </times>
  </xsl:template>

   <xsl:template match="sum">
    <plus>
      <xsl:apply-templates select="@*|*|text()|comment()"/>
    </plus>
  </xsl:template>

  <xsl:template match="metabolite|protein|actor">
    <xsl:variable name="tag">
	<xsl:value-of select="name(.)"/>
      </xsl:variable>
    <species>
      <xsl:attribute name="type">
	<xsl:value-of select="$tag"/>
      </xsl:attribute>
      <xsl:apply-templates select="@* | child::*"/>
    </species>
  </xsl:template>
  
  <xsl:template match="context">
    <reaction>
      <xsl:copy-of select="@*"/>
      <xsl:apply-templates select="child::*"/>
    </reaction>
  </xsl:template>
  <xsl:template match="input">
    <xsl:attribute name="type">inflow</xsl:attribute>
    <product>
      <xsl:copy-of select="@*"/>
    </product>
  </xsl:template>
  <xsl:template match="output">
    <xsl:attribute name="type">outflow</xsl:attribute>
    <reactant>
      <xsl:copy-of select="@*"/>
    </reactant>
  </xsl:template>

  <xsl:template match="*">
    <!--<xsl:message>
      otherwise <xsl:copy-of select="name()"/>
    </xsl:message>-->
      <xsl:variable name="tag">
	<xsl:value-of select="name(.)"/>
      </xsl:variable>
      <xsl:element name="{$tag}">
	<xsl:apply-templates select="@*|*|comment()|text()"/>
      </xsl:element>
  </xsl:template>
  
  <xsl:template match="@*|comment()|text()">
    <xsl:copy-of select="."/>
  </xsl:template>
</xsl:stylesheet>
