<xsl:stylesheet 
    xmlns="http://www.w3.org/1999/xhtml"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
    version="2.0"
    exclude-result-prefixes="xs">

    <xsl:output   
	method="text" 
	version="1.0"
	encoding="utf-8"
	indent="yes"/>

  <xsl:template match="/">
    <xsl:text>import java.util.Arrays;
import java.util.HashSet;
public interface Stoichiometry {
    /**
    * The matrix (for instance for the stoichiometry of a reaction network)
    */
    double[][] MATRIX = new double[][] {
</xsl:text>
    <!--
	{ 1, 0, 0, -1, 0   }, //A
	{ 0, 1, 0, 0, -1   }, //B
	{ 0, 0, -1, 1, 1   }  //C
    -->
    <xsl:for-each select="//matrix/row">
      <xsl:text>    {</xsl:text>
      <xsl:for-each select="column">
	<xsl:value-of select="@value"/>
	<xsl:if test="following-sibling::*">
	  <xsl:text>, </xsl:text>
	</xsl:if>
      </xsl:for-each>
      	<xsl:text>}</xsl:text>
      <xsl:if test="following-sibling::*">
	<xsl:text>,
</xsl:text>
      </xsl:if>
    </xsl:for-each>
    <xsl:text>
    };
    /**
     * true for real values, false for positive positive
     */
     boolean[] REAC_REVERSIBILITIES = new boolean[] {
    </xsl:text>
    <xsl:for-each select="//variables/*">
      <xsl:choose>
	<xsl:when test="name()='dot'">
	  <xsl:text>true</xsl:text>
	</xsl:when>
	<xsl:otherwise>
	  <xsl:text>false</xsl:text>
	</xsl:otherwise>
      </xsl:choose>
      <xsl:if test="following-sibling::*">
	<xsl:text>, </xsl:text>
      </xsl:if>
    </xsl:for-each>
    <xsl:text>};
    
    /**
     * rows
     */
    String[] METABOLITE_NAMES = {</xsl:text>
    <xsl:for-each select="//matrix/*">
      <xsl:text>"</xsl:text>
      <xsl:value-of select="concat('row_',position())"/>
      <xsl:text>"</xsl:text>
      <xsl:if test="following-sibling::*">
	<xsl:text>,</xsl:text>
      </xsl:if>
    </xsl:for-each>
     <xsl:text>};
    /**
     * variables
     */
    String[] REACTION_NAMES = {</xsl:text>
    <xsl:for-each select="//variables/*">
      <xsl:text>"</xsl:text>
      <xsl:apply-templates select="." mode="varname"/>
      <xsl:text>"</xsl:text>
      <xsl:if test="following-sibling::*">
	<xsl:text>,</xsl:text>
      </xsl:if>
    </xsl:for-each>
     <xsl:text>};
   
}
  </xsl:text>
  </xsl:template>

  <!-- needed? -->
  <xsl:template match="dot|posdot|negdot|conc">
    <xsl:value-of select="@spec"/>
  </xsl:template>
  
  <!-- function varname -->
  <xsl:template match="speed" mode="varname">
    <xsl:value-of select="concat('r_',@reaction)"/>
  </xsl:template>
  <xsl:template match="dot" mode="varname">
    <xsl:value-of select="concat('dot_',@spec)"/>
  </xsl:template>
  <xsl:template match="posdot" mode="varname">
    <xsl:value-of select="concat('posdot_',@spec)"/>
  </xsl:template>
  <xsl:template match="negdot" mode="varname">
    <xsl:value-of select="concat('negdot_',@spec)"/>
  </xsl:template>
  <xsl:template match="conc" mode="varname">
    <xsl:value-of select="@spec"/>
  </xsl:template>
  <xsl:template match="var" mode="varname">
    <xsl:value-of select="concat('var_',@id)"/>
  </xsl:template>

 
</xsl:stylesheet>
