<xsl:stylesheet 
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
    version="2.0"
    exclude-result-prefixes="xs">

    <xsl:output   
	method="text" 
	version="1.0"
	encoding="utf-8"
	indent="yes"/>
    
    <xsl:strip-space elements="*" />
    
   
     <xsl:template match="network">
       <xsl:apply-templates select="child::reaction"/>
       <text xml:space="preserve">
</text>
        <xsl:apply-templates select="child::context/child::*" mode="input"/>
        <xsl:apply-templates select="child::context/child::*" mode="output"/>
     </xsl:template>
     
     <xsl:template match="reaction">
       <text>r</text>
       <xsl:apply-templates select="@id" mode="special-chars"/>
       <text xml:space="preserve">: </text>
       <xsl:apply-templates select="child::activator"/>
       <xsl:if test="child::activator"> 
	 <text xml:space="preserve"> --* </text>
       </xsl:if>
       <xsl:apply-templates select="child::accelerator"/>
       <xsl:if test="child::accelerator"> 
	 <text xml:space="preserve"> --o </text>
       </xsl:if>
       <xsl:apply-templates select="child::inhibitor"/>
       <xsl:if test="child::inhibitor"> 
	 <text xml:space="preserve"> --| </text>
       </xsl:if>
       <xsl:apply-templates select="child::reactant"/>
       <text xml:space="preserve"> --> </text>
       <xsl:apply-templates select="child::product"/>
       <text xml:space="preserve">.
</text>
     </xsl:template>

     <xsl:template match="activator|accelerator|reactant|inhibitor|product">
       <xsl:apply-templates select="@spec" mode="special-chars"/>
	 <xsl:if test="name()=following-sibling::*/name()">
	   <text>, </text>
	 </xsl:if>
     </xsl:template>

     <xsl:template match="input|in-out" mode="input">
       <text xml:space="preserve">r_in_</text>
       <xsl:apply-templates select="@spec" mode="special-chars"/>
       <text xml:space="preserve">: --> </text>
       <xsl:apply-templates select="@spec" mode="special-chars"/>
       <text xml:space="preserve">.
</text>
     </xsl:template>
     <xsl:template match="output|in-out" mode="output">
       <text xml:space="preserve">r_out_</text>
       <xsl:apply-templates select="@spec" mode="special-chars"/>
       <text xml:space="preserve">: </text>
       <xsl:apply-templates select="@spec" mode="special-chars"/>
       <text xml:space="preserve"> --> .
</text>
     </xsl:template>

     <xsl:variable name="apos">'</xsl:variable>
     <xsl:template match="@*" mode="special-chars">
       <xsl:value-of select="replace(replace(replace(.,'-','_'),$apos,'_inv'),'\{','')"/>
     </xsl:template>
</xsl:stylesheet>
