<!-- computes stoichiometry matrix for a metabolic network with stoichiometries -->

<xsl:stylesheet 
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
    version="2.0"
    exclude-result-prefixes="xs">

    <xsl:output   
	method="xml" 
	version="1.0"
	encoding="utf-8"
	indent="yes"/>

    <xsl:template match="reaction">
      <reaction>
	<xsl:copy-of select="@*"/>
	<xsl:apply-templates select="
				     *[ not(name()='reactant')  and not(name()='product') ]
				     | reactant[@stoichiometry]
				     | product[@stoichiometry]"/>
      </reaction>
    </xsl:template>
    
    <xsl:template match="*">
      <xsl:variable name="name">
	<xsl:value-of select="name()"/>
      </xsl:variable>
      <xsl:element name="{$name}">
	<xsl:apply-templates select="*|@*|text()|comment()"/>
      </xsl:element>
    </xsl:template>

    <xsl:template match="@*| text()|comment()">
      <xsl:copy-of select="."/>
    </xsl:template>
</xsl:stylesheet>
