<!-- converts stoichiometry matrix into transposed metabolic network -->

<xsl:stylesheet 
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
    version="2.0"
    exclude-result-prefixes="xs">

    <xsl:output   
	method="xml" 
	version="1.0"
	encoding="utf-8"
	indent="yes"/>

    <xsl:template match="matrix">
      <network>
	<xsl:copy-of select="@*"/>
	<xsl:apply-templates select="metabolite[1]/reaction" mode="to-species"/>
	<xsl:apply-templates select="metabolite" mode="to-reaction"/>
      </network>
    </xsl:template>

    <xsl:template match="reaction" mode="to-species">
      <metabolite>
	<xsl:copy-of select="@*[not(name()='stoichiometry')]
			     [not(name()='candidate')]
			     [not(name()='reversible')]     "/>
      </metabolite>
    </xsl:template>
    
    <xsl:template match="metabolite" mode="to-reaction">
      <reaction reversible="yes">
	<xsl:copy-of select="@*"/>
	<xsl:for-each select="reaction[@stoichiometry&lt;0]">
	  <product>
	    <xsl:attribute name="spec">
	      <xsl:copy-of select="@id"/>
	    </xsl:attribute>
	  </product>
	</xsl:for-each>
	<xsl:for-each select="reaction[@stoichiometry&gt;0]">
	  <reactant>
	    <xsl:attribute name="spec">
	      <xsl:copy-of select="@id"/>
	    </xsl:attribute>
	  </reactant>
	</xsl:for-each>
      </reaction>
    </xsl:template>
     
</xsl:stylesheet>
