<xsl:stylesheet 
    xmlns="http://www.w3.org/1999/xhtml"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
    version="2.0"
    exclude-result-prefixes="xs">

    <xsl:output   
	method="text" 
	version="1.0"
	encoding="utf-8"
	indent="yes"/>
    
    <xsl:param name="OUTPUT_DIR"     required="yes"/>
    <xsl:param name="NODE"            required="yes"/>
      

    <xsl:template match="/">
     <!--<xsl:message>
	graph <xsl:copy-of select="."/>
	</xsl:message>
     <xsl:message> node <xsl:copy-of select="$NODE"/>
      </xsl:message>-->
      <xsl:apply-templates select="graph"/>
    </xsl:template>
      
    <xsl:template match="graph">
      

      <xsl:variable name="node">
	<xsl:copy-of select="node[@id=$NODE]"/>
      </xsl:variable>



      

      <text xml:space="preserve">      
	\documentclass{standalone}

%\usepackage[a0paper]{geometry}
\usepackage[colorlinks]{hyperref}

\usepackage{longtable}
\usepackage{capt-of}

\usepackage[utf8]{inputenc}
\usepackage{textalpha}

\usepackage{amsmath}
\usepackage{amssymb}
\usepackage{natbib}
\usepackage{stmaryrd}
\usepackage{mathrsfs}
\usepackage{bussproofs}
\usepackage{graphicx}
\usepackage{color}
\usepackage{multirow}
\usepackage{array,multirow,makecell}
\usepackage[T1]{fontenc}
\usepackage{Latex/inference}
\usepackage{xspace}
\usepackage{listings}
\usepackage[version=3]{mhchem}
\usepackage{pdftexcmds} % for switch-macros
\usepackage{Latex/macros}
      </text>
      
      <xsl:if test="not(//*[@latex-look])">
	<text>
	  \usepackage{Latex/macros-species}
	  \usepackage{Latex/switch-macros}
	</text>
      </xsl:if>

      <xsl:if test="//*[@latex-look]">
	<text>
	\usepackage{</text>
	<xsl:value-of select="$OUTPUT_DIR"/><text>/latex-macros} 
	</text>
      </xsl:if>

	
  <text>\usepackage[dvipsnames]{xcolor}
  \usepackage{tikz}
  \usetikzlibrary{math} %needed tikz library
  \definecolor{lightblue}{HTML}{92dcec}

\usepackage{Latex/tikz-macros}

\usepackage{mathtools}
\DeclarePairedDelimiter{\ceiling}{\lceil}{\rceil}
\DeclarePairedDelimiter\floor{\lfloor}{\rfloor}
\usetikzlibrary{decorations.pathmorphing}


\EnableBpAbbreviations

\begin{document}


\begin{tikzpicture}

  \node (hi) at (0,0) [metabolite, label={[label distance=-0.1cm]:$</text>
  <xsl:value-of select="$node/node/@annotation"/>
  <text>$}  ] {</text>
  <xsl:value-of select="$node/node/@label"/>
  <text>};
  

\end{tikzpicture}
\end{document}</text>

</xsl:template>


</xsl:stylesheet>
