### exact equations and constraints

exact-all: 	exact/equations 		\
		exact/flat-equations 		\
		exact/constraints.xml		\
		exact/constraints.tex

exact/equations: do-it
	@echo ++++ start exact rewriting for EQUATIONS=$(EQUATIONS) +++++++++++++
	@mkdir -p $(OUTPUT_DIR)/exact/$(EQUATIONS)
	time python3 system2exactrewriting.py  			\
	--filepath_systemxml $(OUTPUT_DIR)/$(EQUATIONS).xml	\
	--to $(OUTPUT_DIR)/exact/$(EQUATIONS)/equations.xml 	\
	--log warning
	@$(MAKE) MSG=exact/$(EQUATIONS)/equations.xml 		\
		compute-message
exact/flat-equations:
	@$(MAKE) DIR=$(OUTPUT_DIR)/exact/$(EQUATIONS)		\
		FILE=equations					\
		flat
	@$(MAKE) MSG=exact/$(EQUATIONS)/flat-equations.xml 	\
		compute-message

exact/constraints.xml: do-it
	@echo +++ start exact/constraints.xml ++++++++++++++++
	$(SAXON) -xsl:../$(TO)/difference-constraints.xsl	\
		NETWORK=network.xml				\
		EQUATIONS=.					\
		-s:$(OUTPUT_DIR)/exact/$(EQUATIONS)/flat-equations.xml	\
	 	-o:$(OUTPUT_DIR)/exact/$(EQUATIONS)/constraints.xml
	@$(MAKE) MSG=exact/$(EQUATIONS)/constraints.xml 	\
		compute-message

exact/constraints.tex: CDIR=../Constraints
exact/constraints.tex: do-it
	@echo CDIR=$(CDIR)
	$(SAXON) -xsl:$(CDIR)/$(TO)/latex-difference-constraints.xsl	\
		-s:$(OUTPUT_DIR)/exact/$(EQUATIONS)/constraints.xml	\
	 	-o:$(OUTPUT_DIR)/exact/$(EQUATIONS)/constraints.tex
	@$(MAKE) MSG=exact/$(EQUATIONS)/constraints.tex 		\
		compute-message
