## minsupp: minimal support consequenqes of linear equations

minsupp-equations: minsupp-msg			\
		minsupp/matrix.xml		\
		minsupp/Stoichiometry.java	\
		fluxes				\
		minsupp/equations.xml
	@$(MAKE) DIR=$(OUTPUT_DIR)		\
		FILE=equations		 	\
		flat

minsupp-msg:
	@echo
	@echo ++++ prepare minsupp EQUATIONS=$(EQUATIONS) +++++++++++++

minsupp/matrix.xml:
	@echo EQUATIONS=$(EQUATIONS)
	@$(MAKE) validate-linear-equations		
	python3 system2matrix.py  			\
	--filepath_systemxml 				\
		$(OUTPUT_DIR)/linear-equations.xml	\
	--to $(OUTPUT_DIR)/matrix.xml 			\
	--log warning
	@$(MAKE) MSG=minsupp/$(EQUATIONS)/matrix.xml 	\
		compute-message


fluxes: do-it
	@echo ++++++ fluxes started with EQUATIONS=$(EQUATIONS) ++++++++++++++++++++++++
	cd minsupp && $(MAKE) 	SOURCE=$(NETWORK) 		\
		EQUATIONS=$(EQUATIONS)				\
		STOICHIOMETRY_XMLFILE=../$(OUTPUT_DIR)/matrix.xml \
		OUTPUT_DIR=../$(OUTPUT_DIR)			\
		NETWORK_FILE=../$(OUTPUT_DIR)/../../network.xml	\
	       	TARGET=main-fluxes start		
#	xmllint --dtdvalid equations-1.1.dtd                  	\
#		$(OUTPUT_DIR)/equations.xml > tmp

minsupp/equations.xml: do-it
	@cd minsupp && $(MAKE) 	SOURCE=$(NETWORK) 		\
		EQUATIONS=$(EQUATIONS)				\
		STOICHIOMETRY_XMLFILE=../$(OUTPUT_DIR)/matrix.xml \
		OUTPUT_DIR=../$(OUTPUT_DIR)			\
		NETWORK_FILE=../$(OUTPUT_DIR)/../../network.xml	\
		TRUE_NETWORK_FILE=../$(OUTPUT_DIR)/network.xml	\
	       	TARGET=main		
	xmllint --dtdvalid equations-1.1.dtd                  	\
		$(OUTPUT_DIR)/equations.xml > tmp

# obsolet below
minsupp/Stoichiometry.java:
	@$(SAXON) -xsl:java-matrix.xsl				\
		-s:$(OUTPUT_DIR)/matrix.xml			\
		-o:$(OUTPUT_DIR)/Stoichiometry.java
	@$(MAKE) MSG=minsupp/$(EQUATIONS)/Stoichiometry.java	\
		compute-message

LIN-EQU = $(OUTPUT_DIR)/minsupp/$(DOT-EQUATIONS)
new-minsupp-$(DOT-EQUATIONS)/Stoichiometry.java:
	sed \
	-e 's/^public class Stoichiometry_fromxml/public class Stoichiometry/g' \
	-e '/>>> FILENAME MATRIX DEFINITION <<</a FILENAME = "$(LIN-EQU)/matrix.xml";'\
		Stoichiometry_fromxml.java > $(LIN-EQU)/Stoichiometry.java
