MAKE  		= make --no-print-directory
LABEL_DIR	= Labels
# CONVERT	= convert -density 200
# CONVERT		= img2pdf
CONVERT		= pdftoppm

all-nodes: NODES=$(shell xmlstarlet sel -t -v 			\
	"//*[self::reaction or self::variable or self::metabolite or self::actor or self::species]/@id" 	\
	$(OUTPUT_DIR)/network.xml)
all-nodes:
	@echo NODES=$(NODES)


ifeq ($(LABELS),true)
all-labels: NODES=$(shell xmlstarlet sel -t -v 			\
	"//*[self::reaction or self::variable or self::metabolite or self::actor or self::species]/@id" 	\
	$(OUTPUT_DIR)/network.xml)
all-labels: print_dir
	@echo -- --------------------------------	
	@echo -- create pdf-labels for
	@echo --	nodes=$(NODES)
	@$(MAKE) print_dir
	@echo -- --------------------------------	
	@for node in $(NODES); do		\
		$(MAKE) NODE=$$node label;	\
	done
else
all-labels:
	@echo ---- labels are not recomputed since LABELS=$(LABELS) -----------
endif

print_dir: do-it
	@echo -- dir=$(OUTPUT_DIR)/$(LABEL_DIR)

dirs: do-it
	@mkdir -p $(LABEL_DIR)
label: dirs do-it
#	@echo NODE=$(NODE)
	@make NODE=$(NODE) node.tex node.pdf node.png

NODE=D
node.tex:
	@$(SAXON) -xsl:$(TO)/label-latex-template.xsl 		\
		OUTPUT_DIR=$(OUTPUT_DIR)			\
		NODE=$(NODE)					\
		-s:$(OUTPUT_DIR)/graph-keep-pos.xml		\
	 	-o:$(OUTPUT_DIR)/$(LABEL_DIR)/$(NODE).tex
	@$(MAKE) MSG=$(LABEL_DIR)/$(NODE).tex compute-message	


node.pdf: do-it
	@pdflatex -output-directory=$(OUTPUT_DIR)/$(LABEL_DIR)	\
		$(OUTPUT_DIR)/$(LABEL_DIR)/$(NODE).tex > tmp
	@$(MAKE) MSG=$(LABEL_DIR)/$(NODE).pdf compute-message

node.png: do-it
	@$(CONVERT) $(OUTPUT_DIR)/$(LABEL_DIR)/$(NODE).pdf	\
		 -png > $(OUTPUT_DIR)/$(LABEL_DIR)/$(NODE).png
	@$(MAKE) MSG=$(LABEL_DIR)/$(NODE).png compute-message	

o:
	@open $(OUTPUT_DIR)/$(LABEL_DIR)/$(NODE).png
do-it: 
