## ######################################################
# Core SBML compilers and schema validation are supported
# on Linux and MacOS. Window is not supported.
#
## #######################################################
# As prerequirments you mainly need the same packages
# as for BioComputing's Network-Graph tools
#
# By default the installation is described for Linux.
# For MacOS, you need to use: 
#     brew
#  instead of 
#     apt-get
## ########################################################


# - - - - conda - - - - - - - -
# Best it to make a dedicated conda environnement with everything you need
conda create -n biocomp
conda info -e
conda activate biocomp
conda install -c anaconda python=3
which python
which pip
# - - - - - - - - - - - - - - - - - -



#------- xmllint    ( Validate XML schemas.
#                     Comes with the linux package libxml2-utils)

apt-get install libxml2-utils

# ------- pdflatex/tikz ( Produce output graphs.
#                         Comes with the package texlive-full)

apt-get install texlive-full

# XPath queries from the command line

apt-get install xmlstartlet

# for pdftoppm to convert pdf to png

apt-get install poppler-qt5

# apt-get install poppler-utils

# ------- make      ( For programming with Saxon XSLT.
#                   Available on standard Linux or MacOs distributions.
#                   On Windows, the required additional engineering 
#	           is currently not provided)
# ------- SAXON home edition (free)
#                 ( As programming platform we use the XML
#                  transformation language XSLT.
#                  Saxon is provided as the jar-file Saxon/9he.jar but
#                  requires to set the shell variables SAXONPATH.)

# export SAXONPATH=$PWD/Reaction-network/Graph/Saxon/saxon9he.jar
export SAXONPATH=$PWD/Reaction-networks/Graph/Saxon/saxon-he-10.6.jar

# -------- java         (is need to run the SAXON jar.
#                        It may comes with JDK, the Java Development Kit )	#

# -------- python3 and pip3  (for running graphviz)

apt-get install python3
# python3 get-pip.py

#-----------graphviz -----------

#          graphviz can layout graphs.
#          in order to get the graphviz python script, you will need to
#          install the python packages python-graphviz and pydotplus.
#	   Usually this is done by using pip:

#   pip install python-graphviz

  pip3 install graphviz
  pip3 install pydotplus

  pip3 install pydot
  pip3 install pydot-ng

# In some systems, the pip3 command for python version 3 is named pip instead.

#----------- ImageMagick
# It is a collection of command-line tools that we use to process some images
# (to render the networks as png)
# Follow https://imagemagick.org/script/download.php to install
# and if you encounter this error while using the tool
# 		convert-im6.q16: attempt to perform an operation not allowed by the security policy
# you can follow the procedure described here : https://askubuntu.com/a/1127265


## ###################################################################
##  for testing do
## ###################################################################

make top

## ###################################################################
##  for documentation of the package
## ###################################################################

cat README.mk

## ###################################################################
##  for documentation of Core-SBML
## ###################################################################

echo "documentation at https://biocomputing.univ-lille.fr/core-sbml"
