<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet 
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
    xmlns:mathml="http://www.w3.org/1998/Math/MathML"
    version="2.0"
    exclude-result-prefixes="xs rdf xsl mathml"
    >

  <xsl:output   
      method="xml" 
      version="1.0"
      encoding="utf-8"
      indent="yes"/>
  <xsl:param name="NETWORK"      required="no"/>
  <xsl:variable name="DEBUG">false</xsl:variable>

 
  <xsl:template match="network">
    <xsl:variable name="start-pair">
      <pair>
	<unordered>
	  <xsl:copy-of select="variable|expression"/>
	</unordered>
	<ordered/>
      </pair>
    </xsl:variable>
 <!--   <xsl:message> - start-pair <xsl:copy-of select="$start-pair"/>
    </xsl:message>-->
    <xsl:variable name="end-pair">
      <xsl:apply-templates select="$start-pair" mode="sort"/>
    </xsl:variable>
     <!--<xsl:message> - end-pair <xsl:copy-of select="$end-pair"/>
    </xsl:message>-->
    <xsl:variable name="result">
      <network mode="ordered">
	<xsl:copy-of select="@*|function"/>
	<xsl:copy-of select="$end-pair/pair/ordered/*"/>
	<xsl:copy-of select="reaction"/>
      </network>
    </xsl:variable>
    <xsl:copy-of select="$result"/>
 <!--   <xsl:message>
      sort result
      <xsl:copy-of select="$result"/>
    </xsl:message> -->
  </xsl:template>

  <!-- function apply-->

  <xsl:template match="pair"  mode="sort">
    <xsl:if test="$DEBUG='true'">
      <xsl:message> sort
      - unordered <xsl:copy-of select="count(unordered/*)"/>
      - ordered <xsl:copy-of select="count(ordered/*)"/>
      <!--- pair <xsl:copy-of select="."/>-->
      </xsl:message>
    </xsl:if>
    <xsl:choose>
      <xsl:when test="unordered/*">
	<xsl:message>-------- sort unordered <xsl:value-of select="count(unordered/*)"/>
	</xsl:message>
	<xsl:variable name="top">
	  <xsl:apply-templates select="." mode="top"/>
	</xsl:variable>
<!--	<xsl:message> top
	- <xsl:copy-of select="$top"/>
	</xsl:message>-->
	<xsl:variable name="next-pair">
	  <pair>
	    <unordered>
	      <xsl:copy-of select="unordered/*[not(@id=$top//*/@id)]"/>
	    </unordered>
	    <ordered>
	      <xsl:copy-of select="ordered/*"/>
	      <xsl:copy-of select="unordered/*[@id=$top//*/@id]"/>
	    </ordered>
	  </pair>
	</xsl:variable>
	<xsl:apply-templates select="$next-pair" mode="sort"/>
      </xsl:when>
      
      <xsl:otherwise>
	<xsl:message> - sort finished
	</xsl:message>
	<xsl:copy-of select="."/>
      </xsl:otherwise>
    </xsl:choose>
      
  </xsl:template>

  <xsl:template match="unordered"  mode="top">
    <xsl:variable name="self">
      <xsl:copy-of select="."/>
    </xsl:variable>
    <xsl:variable name="next-one">
      <next>
	<xsl:for-each select="variable|expression">
	  <xsl:variable name="element">
	    <xsl:copy-of select="."/>
	  </xsl:variable>
	  <xsl:for-each select="$element//(var|expr)
				[not(@type='differential')]
				[not(@type='species')]
				[not(@id=$element/*/@id)]">
	    <xsl:copy-of select="."/>
	  </xsl:for-each>
	</xsl:for-each>
      </next>
    </xsl:variable>
    <xsl:variable name="next">
      <next>
	<xsl:copy-of select="$next-one/next/*[@id=$self/unordered/*/@id]
			     [not(@id=preceding-sibling::*/@id)]"/>
      </next>
    </xsl:variable>
    <xsl:if test="$DEBUG='true'">
      <xsl:message>
	<!-- - next-one <xsl:copy-of select="$next-one"/> -->
	- next <xsl:copy-of select="$next"/>
      </xsl:message>
    </xsl:if>
    <xsl:choose>
      <xsl:when test="$next/next/*">
	<xsl:variable name="next-unordered">
	  <unordered>
	    <xsl:for-each select="$next/next/*">
	      <xsl:variable name="id">
		<xsl:value-of select="@id"/>
	      </xsl:variable>
	      <xsl:copy-of select="$self/unordered/*[@id=$id]"/>
	    </xsl:for-each>
	  </unordered>
	</xsl:variable>
	<xsl:apply-templates select="$next-unordered" mode="top"/>
      </xsl:when>
      <xsl:otherwise>
	<xsl:copy-of select="(variable|expression)"/>
      </xsl:otherwise>
   </xsl:choose>
  </xsl:template>

   </xsl:stylesheet>
