<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet 
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
   xpath-default-namespace="http://www.sbml.org/sbml/level2/version4"   
    version="2.0"
    exclude-result-prefixes="xs">

  <xsl:output   
      method="xml" 
      version="1.0"
      encoding="utf-8"
      indent="yes"/>

  <xsl:param name="NETWORK"          required="yes"/>
  <xsl:param name="OUTPUT_DIR"      required="yes"/>
  <xsl:variable name="DEBUG">false</xsl:variable>

  
  <xsl:variable name="NETWORK-POSITIONS">
    <xsl:copy-of select="document(concat($OUTPUT_DIR,'/',$NETWORK,'/positions.xml'))"/>
  </xsl:variable>

  <xsl:template match="/">
    <xsl:if test="$DEBUG='true'">
      <xsl:message>
      NETWORK-POSITION=
      <xsl:copy-of select="$NETWORK-POSITIONS"/>
      </xsl:message>
    </xsl:if>
    <xsl:apply-templates select="*"/>
  </xsl:template>
  
    <xsl:template match="text()|comment()|@*">
    <xsl:copy-of select="."/>
  </xsl:template>
  
  <xsl:template match="*[not(
		           local-name()='species'
		       or local-name()='variable'
		       or local-name()='metabolite'
		       or local-name()='actor'
		       or local-name()='reaction')]">
   <xsl:variable name="name">
     <xsl:value-of select="name()"/>
   </xsl:variable>
   <xsl:if test="$DEBUG='true'">
     <xsl:message> zip <xsl:value-of select="name()"/>
     </xsl:message>
   </xsl:if>
   <xsl:element name="{$name}">
     <xsl:apply-templates select="*|@*|text()|comment()"/>
   </xsl:element>
 </xsl:template>

 <xsl:template match="*">
    <xsl:variable name="name">
      <xsl:value-of select="name()"/>
    </xsl:variable>
    <xsl:variable name="id">
      <xsl:value-of select="@id"/>
    </xsl:variable>
    <xsl:if test="$DEBUG='true'">
      <xsl:message>
	name=<xsl:copy-of select="$name"/>
	id=<xsl:copy-of select="$id"/>
	pos-x=<xsl:value-of select="$NETWORK-POSITIONS//*[@id=$id]/@x"/>
	pos-y=<xsl:value-of select="$NETWORK-POSITIONS//*[@id=$id]/@y"/>
      </xsl:message>
    </xsl:if>
      <xsl:element name="{$name}">
      <xsl:copy-of select="$NETWORK-POSITIONS//*[@id=$id]/(@x|@y)"/>
     <xsl:apply-templates
	 select="*|text()|comment()
		 |@*[not(name()='x')][not(name()='y')]"/>
   </xsl:element>
  </xsl:template>
</xsl:stylesheet>
